var initialAsteroids = 4;   // max number of initial asteroids
var bodyWidth = 500;		// width of the gadget
var bodyHeight = 400;		// height of the gadget
var refreshRate = 30;		// refresh rate in ms
var maxFire = 4;			// maximum number of bullets
var maxUFOFire = 2;			// maximum number of bullets from UFO's
var difficulty = 0.5;		// game level, used to set speed
var maxDifficulty = 4;		// max difficulty level
var maxUFO = 2;				// maximum number of UFO's on screen at once
var fireSpeed = 10;			// speed of fire
var extraLifeAt = 10000;	// grant extra life at
var sound = true;			// should we play sounds
var haveFocus = true;		// do we currently have focus

// ************************
// XB360 controller buttons
// valid values are: A, B, X, Y, LB, RB, Back, Start, LeftStick, RightStick
// ************************
var gpFire = "B";
var gpThrust = "A";
var gpHyperspace = "RB";
// ************************


var iTimerID1;								//event timer: main code loop
var iTimerID2;								//event timer: dead/game over/hyperspace
var turning = 0;							//the direction we're turning
var moving = false;							//is thrust being applied
var fire = new Array(maxFire);    			//X, Y, movement x, movement y
var maxFireUFO = maxUFOFire*maxUFO			//max number of bullets from all UFO's
var fireUFO = new Array(maxFireUFO);		//X, Y, movement x, movement y
var maxFireLife = parseInt(fireSpeed*3);	//max updates before fire ends
var nextFire = 0;							//Next fire index#
var nextFireUFO = 0;						//Next fire index# from UFO's
var fireCount = 0;							//fire currently on screen
var fireCountUFO = 0;						//fire currently on screen from UFO's
var maxAsteroids = initialAsteroids*4;		//Max asteroids on screen at once
var asteroid = new Array(maxAsteroids);		//X, Y, rotation, rotation speed, movement x, movement y, wdith, height
var maxAsteroidStyles = 2;					//How many styles of asteroid how we created
var asteroidStyle = new Array(maxAsteroidStyles*3);	//Asteriod VML code
var asteroidVML = new Array(maxAsteroidStyles*3);	//Asteroid dimensions
var score = 0;								//current score
var zoom = 1.0;								//zoom scale of the gadget
var updating = false;						//are we updating the screen
var firing = false;							//are we firing
var slowFire = true;						//used to halve the rate of fire
var ufoStyle = new Array(1);				//UFO VML code
var ufoVML = new Array(1);					//UFO dimensions
var ufos = new Array(maxUFO);				//X, Y, movement x, movement y, width, height, type, radius
var nextUFO = 0;							//Next UFO index#
var asteroidCount = initialAsteroids;		//Asteroids currently on screen
var ufoCount = 0;							//UFO's currently on screen
var shipRadius = 5;							//size of ship for collision detection
var maxDust = 100;							//max dust at once
var maxDustPerExplosion = 10;				//max dust per explosion
var dust = new Array(maxDust);				//X, Y, movement X, movement Y, life, size
var nextDust = 0;							//Next dust index#
var dustCount = 0;							//amount of dust on screen
var offScreen = false;						//counter to wait before recreating our ship
var demo = true;							//are we demoing or playing
var lives = 0;								//number of lives
var flashStart = 1;							//used to flash "push start"
var thumpcounter;							//countdown to play the next thump.  counter, heart rate, sound to play
var highScores= new Array(9);				//high score table
var enteringHiScore = -1;					//used to redirect keys when ev've got a high score
var enteringHiScoreChar;					//used to track which character we're changing
var startingDifficulty = difficulty;		//the starting difficulty
var strokeweight;							//the thickness of the vectors
var cue_thrust = null, cue_lsaucer = null, cue_ssaucer = null;

var gadgetPath = System.Gadget.path;
var charbackslash = new RegExp("\\\\", "g");

var ship = new Array(7);					//X, Y, rotation, movement x, movement y, _, width, height

asteroidStyle[0] = "m 38,0 l 55,8, 63,29, 55,48, 28,63, 9,55, 0,29, 17,6 x e";
asteroidVML[0] = [31, 31, 33];  //centreX, centreY, radius

asteroidStyle[1] = "m 21,0 l 49,4, 63,21, 61,44, 46,43, 26,63, 8,50, 15,35, 0,25 x e";
asteroidVML[1] = [31, 31, 30];  //centreX, centreY, radius

asteroidStyle[2] = "m 19,0 l 27,4, 31,15, 27,24, 14,31, 4,27, 0,15, 8,3 x e";
asteroidVML[2] = [15, 15, 16];  //centreX, centreY, radius

asteroidStyle[3] = "m 10,0 l 24,2, 31,10, 30,22, 23,21, 13,31, 4,25, 7,16, 0,12 x e";
asteroidVML[3] = [15, 15, 15];  //centreX, centreY, radius

asteroidStyle[4] = "m 10,0 l 14,2, 15,8, 14,12, 7,15, 2,14, 0,7, 4,2 x e";
asteroidVML[4] = [7, 7, 9];  //centreX, centreY, radius

asteroidStyle[5] = "m 5,0 l 12,1, 15,5, 15,10, 11,10, 7,15, 2,12, 3,8, 0,6 x e";
asteroidVML[5] = [7, 7, 8];  //centreX, centreY, radius

ufoStyle[0] = "m 0,12 l 0,10, 8,6, 10,1, 18,1, 20,6, 28,10, 28,12, 19,17, 8,17, 0,12 m 0,11 l 28,11 m 8,6 l 20,6 e";
ufoVML[0] = [14, 8.5, 8.5];		//centreX, centreY, radius

ufoStyle[1] = "m 0,12 l 0,10, 8,6, 10,1, 18,1, 20,6, 28,10, 28,12, 19,17, 8,17, 0,12 m 0,11 l 28,11 m 8,6 l 20,6 e";
ufoVML[1] = [7, 6, 6];		//centreX, centreY, radius

var shipStyle = new Array(3);   //used to explode the ship
shipStyle[0] = [0,16, 6,0];
shipStyle[1] = [6,0, 12,16];
shipStyle[2] = [12,16, 6,12];
shipStyle[3] = [6,12, 0,16];

var alphabet = new Array(90);
alphabet[33] = "m 7,3 l 4,3, 4,7, 7,7 m 2,0 l 8,0, 10,2, 10,8, 8,10, 2,10, 0,8, 0,2 x e";	//@
alphabet[45] = "m 0,10 l 10,10 e";									//-
alphabet[48] = "m 0,0 l 10,0, 10,10, 0,10 x e";						//0
alphabet[49] = "m 5,0 l 5,10 e";									//1
alphabet[50] = "m 0,0 l 10,0, 10,5, 0,5, 0,10, 10,10 e";			//2
alphabet[51] = "m 0,0 l 10,0, 10,10, 0,10 m 0,5 l 10,5 e";			//3
alphabet[52] = "m 0,0 l 0,5, 10,5 m 10,0 l 10,10 e";				//4
alphabet[53] = "m 10,0 l 0,0, 0,5, 10,5, 10,10, 0,10 e";			//5
alphabet[54] = "m 0,0 l 0,10, 10,10, 10,5, 0,5 e";					//6
alphabet[55] = "m 0,0 l 10,0, 10,10 e";								//7
alphabet[56] = "m 0,0 l 10,0, 10,10, 0,10, 0,0 m 0,5 l 10,5 e";		//8
alphabet[57] = "m 10,10 l 10,0, 0,0, 0,5, 10,5 e";					//9

alphabet[65] = "m 0,10 l 0,3, 5,0, 10,3, 10,10 m 0,6 l 10,6 e";		//A
alphabet[66] = "m 0,10 l 0,0, 6,0, 10,2, 10,3, 6,5, 0,5 m 0,10 l 6,10, 10,8, 10,7, 6,5 e";	//B
alphabet[67] = "m 10,0 l 0,0, 0,10, 10,10 e";						//C
alphabet[68] = "m 0,0 l 5,0 10,4, 10,6 5,10, 0,10 x e";				//D
alphabet[69] = "m 10,0 l 0,0, 0,10, 10,10 m 0,5 l 5,5 e";			//E
alphabet[70] = "m 0,10 l 0,0, 10,0 m 0,5 l 5,5 e";					//F
alphabet[71] = "m 10,4 l 10,0, 0,0, 0,10, 10,10, 10,6, 5,6 e";		//G
alphabet[72] = "m 0,10 l 0,0 m 10,10 l 10,0 m 0,5 l 10,5 e";		//H
alphabet[73] = "m 0,0 l 10,0 m 0,10 l 10,10 m 5,0 l 5,10 e";		//I
alphabet[74] = "m 10,0 l 10,10, 4,10, 0,6 e";						//J
alphabet[75] = "m 0,0 l 0,10 m 10,0 l 0,5, 10,10 e";				//K
alphabet[76] = "m 0,0 l 0,10, 10,10 e";								//L
alphabet[77] = "m 0,10 l 0,0, 5,3, 10,0, 10,10 e";					//M
alphabet[78] = "m 0,10 l 0,0, 10,10, 10,0 e";						//N
alphabet[79] = "m 0,0 l 10,0, 10,10, 0,10 x e";						//O
alphabet[80] = "m 0,10 l 0,0, 10,0, 10,5, 0,5 e";					//P
alphabet[81] = "m 10,10 l 6,6 m 0,0 l 10,0, 10,6, 6,10, 0,10 x e";	//Q
alphabet[82] = "m 0,10 l 0,0, 10,0, 10,5, 0,5 m 4,5 l 10,10 e";		//R
alphabet[83] = "m 0,10 l 10,10, 10,5, 0,5, 0,0, 10,0 e";			//S
alphabet[84] = "m 5,10 l 5,0 m 0,0 l 10,0 e";						//T
alphabet[85] = "m 0,0 l 0,10, 10,10, 10,0 e";						//U
alphabet[86] = "m 0,0 l 5,10, 10,0 e";								//V
alphabet[87] = "m 0,0 l 0,10, 5,6, 10,10, 10, 0 e";					//W
alphabet[88] = "m 0,0 l 10,10 m 0,10 l 10,0 e";						//X
alphabet[89] = "m 0,0 l 5,4 10,0 m 5,4 l 5,10 e";					//Y
alphabet[90] = "m 0,0 l 10,0, 0,10, 10,10 e";						//Z

System.Gadget.onDock = dockedState;
System.Gadget.onUndock = dockedState;

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

var bDebug = oFSO.FileExists(gadgetPath+"\\debug.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debug.txt", 2);
} catch(err) {bDebug = false; debugLog("Open debug.txt error"+err.name+" - "+err.message)}

//try to initialise the sounds
if (sound)
{
	var axDllClass = "DSXLib.DSX";
	var axDllCLSID = "{B9281627-6845-309B-9A99-420E09301192}";
	var axDllAssembly = "DSXLib";
	var axDllVersion = "1.0.2747.28581";
	var axDllRuntimeVer = "v2.0.50727";
	var axDllFilename = "dsxlib.dll";

	var DSXLib, regRoot;

	//register graphics library
	if(bDebug) debugLog("Register ActiveX");
	if(bDebug) debugLog("trying HKCU");
	if (!activeDLL("HKCU")) {
		if(bDebug) debugLog("trying HKLM");
		if (!activeDLL("HKLM"))
			debugLog("Error creating DSXLib ActiveX object");
	}
}


// set size by docked state
function dockedState() {
	if (System.Gadget.docked) {
		strokeweight = 0.25;
		changeZoom(128/bodyWidth);
	} else {
		strokeweight = 1.5;
		changeZoom(1.0);
	}
}



// change the gadget zoom level
function changeZoom(j) {
	zoom = j;
	try{
		document.body.style.width = parseInt((bodyWidth+230) * zoom);
		document.body.style.height = parseInt((bodyHeight+130) * zoom);
		gback.src = gback.src;

		//set the div sizes
		var z = document.getElementsByTagName("span");
		for (var i=0; i<z.length; i++)
		{
			z[i].style.width = parseInt(bodyWidth * zoom) + "px";
			z[i].style.height = parseInt(bodyHeight * zoom) + "px";
			z[i].style.top = parseInt(70 * zoom);
			z[i].style.left = parseInt(120 * zoom);
		}

		//set the coordsize
		var z = divBodyGraphics.getElementsByTagName("group");
		for (var i=0; i<z.length; i++)
		{
			z[i].coordsize = bodyWidth+","+bodyHeight;
			z[i].style.width = parseInt(bodyWidth * zoom)+"px";
			z[i].style.height = parseInt(bodyHeight * zoom)+"px";
		}

		var z = divBodyStatic.getElementsByTagName("group");
		for (var i=0; i<z.length; i++)
		{
			z[i].coordsize = bodyWidth+","+bodyHeight;
			z[i].style.width = "100%";
			z[i].style.height = "100%";
		}
		bodyText.coordsize = bodyWidth+","+bodyHeight;
		bodyText.style.width = "100%";
		bodyText.style.height = "100%";

		//set the stroke weight
		var z = vmlShapeTypes.getElementsByTagName("shapetype");
		for (var i=0; i<z.length; i++)
			z[i].strokeweight = strokeweight;

		//set the overlay images
		if (j == 1.0) {
			overlay1.src = "images/overlay1.png";
			overlay1.style.width = 730;
			overlay1.style.height = 530;
			overlay2.src = "images/overlay2.png";
			overlay2.style.width = 730;
			overlay2.style.height = 530;
		} else {
			overlay1.src = "images/overlay1small.png";
			overlay1.style.width = 186;
			overlay1.style.height = 135;
			overlay2.src = "images/overlay2small.png";
			overlay2.style.width = 186;
			overlay2.style.height = 135;
		}
	} catch(err) {debugLog("changeZoom: "+err.name+" - "+err.message)}	
}



// Start up code, initialise variables etc
function startUpGadget() {
	var obj, astStyle, objVML;

	//set the size of the Gadget
	dockedState();

	//initialise the ship
	ship[0] = -1000;	//X
	ship[1] = -1000;	//Y
	ship[2] = 0;		//rotation
	ship[3] = 0;		//movement X
	ship[4] = 0;		//movement Y
	ship[6] = 12/2;		//width
	ship[7] = 20/2;		//height
	
	//initialise fire
	for(var j=0; j<maxFire; j++)
		fire[j] = [0,0,0,0,0];

	for(var j=0; j<maxFireUFO; j++)
		fireUFO[j] = [0,0,0,0,0];

	//initialise asteroids
	for(var j=0; j<=maxAsteroids; j++)
	{
		asteroid[j] = new Array(9);
		asteroid[j][6] = 0;
	}
	
	//initialise ufos
	for(var j=0; j<maxUFO; j++)
	{
		ufos[j] = new Array(7);
		ufos[j][2] = 0;
	}

	//initialise dust
	for(var j=0; j<maxDust; j++)
		dust[j] = [0,0,0,0,0,0];

	//initialise highscores
	for(var j=0; j<10; j++)
		highScores[j] = [0, "   "];

	loadHighScores();

	//initialise the vml shapetypes
	for (var j=0; j<91; j++)	// ascii
	{
		if (alphabet[j] != null)
		{
			var obj = document.createElement("<v:shapetype id='char" + j + "' " +
				"path='" + alphabet[j] + "' " +
				"stroked='true' strokeweight='" + strokeweight + "' strokecolor='white' " +
				"filled='false' coordorigin='0,0'></v:shapetype>");
			vmlShapeTypes.appendChild(obj);
		}
	}

	for (var j=0; j<6; j++)		// asteroids
	{
		var obj = document.createElement("<v:shapetype id='asteroidtype" + j + "' " +
			"path='" + asteroidStyle[j] + "' " +
			"stroked='true' strokeweight='" + strokeweight + "' " +
			"strokecolor='white' filled='false' " +
			"coordsize='" + asteroidVML[j][0]*2 +	"," + asteroidVML[j][1]*2 + "' " +
			"coordorigin='0,0'></v:shapetype>");
		vmlShapeTypes.appendChild(obj);
	}

	for (var j=0; j<2; j++)		// UFOs
	{
		var obj = document.createElement("<v:shapetype id='ufotype" + j + "' " +
			"path='" + ufoStyle[j] + "' "+
			"stroked='true' strokeweight='" + strokeweight + "' " +
			"strokecolor='white' filled='false' coordsize='28,17' coordorigin='0,0'></v:shapetype>");
		vmlShapeTypes.appendChild(obj);
	}

	//create the objects
	initialiseAsteroids();

	//display score
	updateScore();
	updateHighScore();

	//set the focus for the key press events
	self.focus;
	document.body.focus();

	//setup the static text
	displayText(205, 390, "divCopyright", "!1979 atari inc", .5);
	displayText(190, 60, "divPushStart", "push start");
	displayText(195, 190, "divGameOver", "game over");
	divGameOver.style.display = "none";
	displayText(55, 110, "divText1", "your score is one of the ten best", .75);
	divText1.style.display = "none";
	displayText(55, 130, "divText2", "please enter your initials", .75);
	divText2.style.display = "none";
	displayText(55, 150, "divText3", "push rotate to select letter", .75);
	divText3.style.display = "none";
	displayText(55, 170, "divText4", "push hyperspace when letter is correct", .75);
	divText4.style.display = "none";

	//setup the sound driver
	try{
		if (sound)
		{
			sound = DSXLib.Initialize(gadgetPath + "\\sounds\\Asteroids");

			if (!sound) debugLog("Can't initialize XACT");
		}
	} catch(err) {sound = false; debugLog("XACT: "+err.name+" - "+err.message)}	

	//setup the screen update timer
	displayHighScores();
	updateScreen();
	setTimeout(setupTimer, 500);
}



// botch to get around a bug in Sidebar
function setupTimer() {
	iTimerID1 = window.setInterval(updateScreen, refreshRate);
}



// main loop
function updateScreen() {
	//if we're already updating the screen, quit
	if (updating)
		return;
	else
		updating = true;

	try{
		updateAsteroids();
		if (sound) checkGamePad();
		if (!demo)
		{
			updateShip();
			updateFire();
		} else if (enteringHiScore == -1)
		{
			flashStart--;
			if (!flashStart)
			{
				divPushStart.style.display = (divPushStart.style.display != "none") ? "none" : "inline";
				flashStart = 16;
			}
		}
		updateUFOs();
		updateFireUFO();
		updateDust();

		//check if we've cleared them all
		if (asteroidCount == 0)
		{
			//clear the fire
			for(var j=0; j<maxFire; j++)
				if (fire[j][4] != 0)
				{
					fire[j][4]=0;
					document.getElementById("fire"+j).removeNode(true);
				}
			fireCount=0;
	
			//re-initialise
			initialiseAsteroids();
		}

		if (!demo && !offScreen)
		{
			thumpcounter[0]--;
			if (!thumpcounter[0])
				{
					if (thumpcounter[2] == 0)
						playSound("thumplo");
					else
						playSound("thumphi");
				
				thumpcounter[2] = thumpcounter[2] ? 0 : 1;
				thumpcounter[0] = parseInt(thumpcounter[1]);
				thumpcounter[1] = thumpcounter[1] - 1;
				if (thumpcounter[1] < 9)
					thumpcounter[1] = 9;
				}
		}

	} catch(err) {debugLog("us:"+err.name+" - "+err.message)}

	updating = false;
}



function startNewGame() {
	//remove the remaining UFO's
	for(var j=0; j<maxUFO; j++)
		if(ufos[j][2] != 0)
		{
			removeUFO(j);
		}
	ufoCount=0;

	initialiseAsteroids();

	difficulty = startingDifficulty;
	score=0;

	//display score
	updateScore();
}



//initialise the ship after we've died
function initialiseShip() {
	//initialise the ship
	ship[0] = bodyWidth/2;	//X
	ship[1] = bodyHeight/2;	//Y
	ship[2] = 0;			//rotation
	vmlShip.style.display="inline";
	offScreen = false;
}



// setup the initial asteroids
function initialiseAsteroids() {
	//remove the remaining asteroids
	for(var j=0; j<=maxAsteroids; j++)
		if (asteroid[j][6] != 0)
		{
			asteroid[j][6] = 0;
			document.getElementById("groupasteroid"+j).removeNode(true);
		}
	asteroidCount=0;

	for(var j=0; j<initialAsteroids; j++)
	{
		asteroid[j][2] = Math.random()*360;									//Rotation
		asteroid[j][3] = Math.random()*(10*difficulty)-(5*difficulty);		//Rotation Speed
		var angle = (Math.random()*360) / 180 * Math.PI;
		var speed = Math.random()*difficulty+1;
		asteroid[j][4] = speed * Math.sin(angle);							//Movement x
		asteroid[j][5] = speed * Math.cos(angle);							//Movement y
		asteroid[j][8] = parseInt(Math.random()*(maxAsteroidStyles-1) + 0.5);	//Asteroid style
		asteroid[j][6] = asteroidVML[asteroid[j][8]][0];					//Width
		asteroid[j][7] = asteroidVML[asteroid[j][8]][1];					//Height
		asteroid[j][9] = asteroidVML[asteroid[j][8]][2];					//radius
		asteroid[j][0] = (Math.random()<.5) ? -asteroid[j][6] : bodyWidth+asteroid[j][6];	//X
		asteroid[j][1] = Math.random()*bodyHeight;							//Y
		asteroid[j][10] = 0;												//scale
		
		createAsteroid(j);
	}
	asteroidCount = initialAsteroids;

	if (difficulty < maxDifficulty)
		difficulty += 0.2;

	thumpcounter = [50, 50, 0];
}




// Update the ship
function updateShip() {
	try{
		//rotate left/right
		if ((ship[2] = (ship[2] + turning) % 360) < 0)
			ship[2] += 360;
	
		//accelerate the ship if SHIFT is current held down
		if (moving)
		{
			//modify the movement vector
			ship[3] += 0.5 * Math.sin(ship[2]/180*Math.PI);
			ship[4] += 0.5 * Math.cos(ship[2]/180*Math.PI);

			//lets create a dust particle
			if (Math.random()>.5)
			{
				var pa = (ship[2]+(Math.random(10)-5)) % 360;

				var x = ship[0] - shipRadius*2*Math.sin(pa/180*Math.PI);
				var y = ship[1] + shipRadius*2*Math.cos(pa/180*Math.PI);
				
				var xm = Math.random()*3*-Math.sin(pa/180*Math.PI);
				var ym = Math.random()*3*Math.cos(pa/180*Math.PI);
	
				createParticle(x, y, xm, ym);
			}
		}
	
		//move the ship 
		ship[0] = (ship[0] + ship[3] + bodyWidth) % bodyWidth;
		ship[1] = (ship[1] - ship[4] + bodyHeight) % bodyHeight;
		
		//reduce the motion vector
		ship[3] = ship[3] / 1.01;
		ship[4] = ship[4] / 1.01;
	
		//update the graphic		
		vmlShip.style.top = parseInt(ship[1] - ship[7]);
		vmlShip.style.left = parseInt(ship[0] - ship[6]);
		vmlShip.style.rotation = parseInt(ship[2]);
		vmlShipThrust.style.top = vmlShip.style.top;
		vmlShipThrust.style.left = vmlShip.style.left;
		vmlShipThrust.rotation = parseInt(ship[2]);
	} catch(err) {debugLog("updateShip: "+err.name+" - "+err.message)}
}



// update the fire
function updateFire() {
	try{
		//are we firing
		if (firing && fireCount < maxFire && slowFire)
		{
			//create a fire.  1st check if the next fire is free, clear it if it isnt
			if (fire[nextFire][4] != 0)
			{
				obj = document.getElementById("fire"+nextFire);
				fireCount--;
			} else {
				//create the graphic
				obj = document.createElement("<v:polyline id='fire"+nextFire+"' points='0,0, 2,2' stroked='true' strokecolor='white' strokeweight='2' filled='false' coordsize='2,2' coordorigin='2,2' />");
				bodyGraphics.appendChild(obj);
			}

			//set its initial X, Y
			fire[nextFire][0] = ship[0];
			fire[nextFire][1] = ship[1];
			//fire in the same direction as the ship, and add on the ship's motion
			fire[nextFire][2] = (fireSpeed*Math.sin(ship[2]/180*Math.PI)) + ship[3];
			fire[nextFire][3] = (-fireSpeed*Math.cos(ship[2]/180*Math.PI)) - ship[4];
			fire[nextFire][4] = maxFireLife;

			obj.style.top = ship[1];
			obj.style.left = ship[0];

			//increase the counters
			fireCount++;
			nextFire = (nextFire+1) % maxFire;
			playSound("fire");
		}

		//only fire every other update
		if (firing)
			slowFire=slowFire ? false : true;

		//is there any fire to update
		if (fireCount>0)
		{
			for(var j=0; j<maxFire; j++)
			{
				if (fire[j][4] > 0)
				{
					obj = document.getElementById("fire"+j);
					//decrease it's life, if it's 0, kill the graphic and decrease the counter
					if (fire[j][4]-- == 1)
					{
						obj.removeNode(true);
						fireCount--;
					}
					else
					{
						//update the position on screen
						fire[j][0] = (fire[j][0] + fire[j][2] + bodyWidth) % bodyWidth;
						fire[j][1] = (fire[j][1] + fire[j][3] + bodyHeight) % bodyHeight;
						obj.style.left = parseInt(fire[j][0]);
						obj.style.top = parseInt(fire[j][1]);
					}
				}
			}
		}
	} catch(err) {debugLog("updateFire: "+err.name+" - "+err.message)}
}



function updateFireUFO() {
	var obj;

	//is there any fire to update
	if (fireCountUFO>0)
	{
		for(var j=0; j<maxFireUFO; j++)
		{
			if (fireUFO[j][4] > 0)
			{
				obj = document.getElementById("fireUFO" + j);
				//decrease it's life
				fireUFO[j][4]--;
				//if it's 0, kill the graphic and decrease the counter
				if (fireUFO[j][4] == 0)
				{
					obj.removeNode(true);
					fireCountUFO--;
				}
				else
				{
					//update the position on screen
					fireUFO[j][0] = (fireUFO[j][0] + fireUFO[j][2] + bodyWidth) % bodyWidth;
					fireUFO[j][1] = (fireUFO[j][1] + fireUFO[j][3] + bodyHeight) % bodyHeight;
					obj.style.left = parseInt(fireUFO[j][0]);
					obj.style.top = parseInt(fireUFO[j][1]);
				}

				//check if we've hit the ship
				if (checkShip(fireUFO[j][0], fireUFO[j][1], 2))
				{
					obj.removeNode(true);
					fireCountUFO--;
					fireUFO[j][4] = 0;
				}
			}
		}
	}
}


// update the asteroids
function updateAsteroids() {
	var obj, angle, anglesin, anglecos;

	try{
		for(var j=0; j<=maxAsteroids; j++)
		{
			if (asteroid[j][6] != 0)
			{
				obj = document.getElementById("asteroid"+j);
				
				// rotate it
				asteroid[j][2] = (asteroid[j][2] + asteroid[j][3] + 360) % 360;
	
				// move it
				asteroid[j][0] = ((asteroid[j][0] + asteroid[j][4] + bodyWidth + asteroid[j][6]*3) % (bodyWidth + asteroid[j][6]*2)) - asteroid[j][6];
				asteroid[j][1] = ((asteroid[j][1] + asteroid[j][5] + bodyHeight + asteroid[j][7]*3) % (bodyHeight + asteroid[j][7]*2)) - asteroid[j][7];
	
				//update the graphic
				obj.style.left = parseInt(asteroid[j][0] - asteroid[j][6]);
				obj.style.top = parseInt(asteroid[j][1] - asteroid[j][7]);
				obj.rotation = asteroid[j][2];

				//check if it's hit our ship
				if (checkShip(asteroid[j][0], asteroid[j][1], asteroid[j][9]))
					scoreAdd(explodeAsteroid(j));
				//check fire for collision
				else if (checkFire(asteroid[j][0], asteroid[j][1], asteroid[j][9]))
					scoreAdd(explodeAsteroid(j));
				//check UFO's for collision
				else if (checkUFO(asteroid[j][0], asteroid[j][1], asteroid[j][9]) || checkFireUFO(asteroid[j][0], asteroid[j][1], asteroid[j][9]))
					explodeAsteroid(j);
			}
		}
	} catch(err) {debugLog(err.name+" - "+err.message+" "+j)}
}



// check fire for a collision
function checkFire(x, y, r) {
	var xDist, yDist, d;

	if (fireCount>0)
	{
		for(var i=0; i<maxFire; i++)
		{
			if (fire[i][4] > 0)
			{
				xDist = fire[i][0] - x;
				yDist = fire[i][1] - y;
				d = Math.sqrt(xDist*xDist + yDist*yDist);
	
				//has it collided				
				if (d < r)
				{
					//stop the fire from updating and remove the object
					fire[i][4] = 0;
					fireCount--;
					document.getElementById("fire"+i).removeNode(true);
	
					return true;
				}
			}
		}
	}
	return false;
}



// check fire for a collision
function checkFireUFO(x, y, r) {
	var xDist, yDist, d;

	if (fireCountUFO>0)
	{
		for(var i=0; i<maxFireUFO; i++)
		{
			if (fireUFO[i][4] > 0)
			{
				xDist = fireUFO[i][0] - x;
				yDist = fireUFO[i][1] - y;
				d = Math.sqrt(xDist*xDist + yDist*yDist);

				//has it collided				
				if (d < r)
				{
					//stop the fire from updating and remove the object
					fireUFO[i][4] = 0;
					fireCountUFO--;
					document.getElementById("fireUFO"+i).removeNode(true);
	
					return true;
				}
			}
		}
	}
	return false;
}



// key pressed
function keyPress() {
	if (enteringHiScore > -1)
	{
		switch(event.keyCode)
		{
			case 32:	//space
				enteringHiScoreChar++;

				//is this the 3rd initial
				if (enteringHiScoreChar == 3)
				{
					highScores[enteringHiScore][1] = highScores[enteringHiScore][1].replace("-", " ");
					enteringHiScore = -1;
					divInitials.style.display = "none";
					divText1.style.display = "none";
					divText2.style.display = "none";
					divText3.style.display = "none";
					divText4.style.display = "none";
					saveHighScores();

					flashStart = 1;
					displayHighScores();
				} else {
					highScores[enteringHiScore][1] += "A";
					displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
				}
				break;
			case 37:	//left arrow
				//get the ascii code and decrease it
				var initials = highScores[enteringHiScore][1];
				var c = initials.charCodeAt(enteringHiScoreChar);
				c--;
				if (c == 64) c = 32;
				else if (c == 31) c = 90;

				highScores[enteringHiScore][1] = initials.substring(0, enteringHiScoreChar) + String.fromCharCode(c) + initials.substring(enteringHiScoreChar + 1);
				displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
				break;
			case 39:	//right arrow
				//get the ascii code and decrease it
				var initials = highScores[enteringHiScore][1];
				var c = initials.charCodeAt(enteringHiScoreChar);
				c++;
				if (c == 91) c = 32;
				else if (c == 33) c = 65;

				highScores[enteringHiScore][1] = initials.substring(0, enteringHiScoreChar) + String.fromCharCode(c) + initials.substring(enteringHiScoreChar + 1);
				displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
				break;
		}
	} else if (demo && event.keyCode == 32)
	{
		demo = false;
		divPushStart.style.display = "none";
		hideHighScores();
		initialiseShip();
		lives = 3;
		
		//display lives
		updateLives();
		startNewGame();
	} else {
		switch(event.keyCode)
		{
			case 32:	//space
				if (!moving && !offScreen)
				{
					//hide the ship
					vmlShip.style.display="none";
					vmlShipThrust.style.display="none";
					
					//setup a timer to hyperspace
					iTimerID2 = window.setTimeout(hyperspace, 1500);
	
					//stop the ship from affecting the game
					ship[0] = -1000;	//X
					ship[1] = -1000;	//Y
					ship[3] = 0;		//movement X
					ship[4] = 0;		//movement Y
					moving = false;
					firing = false;
					offScreen = true;
				}
				break;
			case 37:	//left arrow
				turning = -10;
				break;
			case 39:	//right arrow
				turning = 10;
				break;
			case 16:	//shift
				if (!moving && !offScreen)
				{
					moving = true;
					playSound("thrust");
	
					//change the graphic to one showing thrust
					vmlShipThrust.style.display="inline";
					vmlShip.style.display="none";
				}
				break;
			case 17:	//ctrl
				if (!offScreen)
					firing = true;
				break;
		}	
	}
}



// key released
function keyUp() {
	switch(event.keyCode)
	{
		// is SHIFT released
		case 16:
			//change the graphic to non-thrust ship
			vmlShip.style.display="inline";
			vmlShipThrust.style.display="none";

			stopSound("thrust");

			moving = false;
			break;
		// left, right arrow
		case 37:
			//check if we've not pressed both arrows
			if (turning<0)
				turning = 0;
			break;
		case 39:
			//check if we've not pressed both arrows
			if (turning>0)
				turning = 0;
			break;
		//CTRL
		case 17:
			firing = false;
	}
}



// create an asteroid object
function createAsteroid(j) {
	createVMLGroup("shape", "asteroid" + j, "type='#asteroidtype" + asteroid[j][8] + "' style='" +
		"left:" + parseInt(asteroid[j][0] - asteroid[j][6]) + "px; " +
		"top:" + parseInt(asteroid[j][1] - asteroid[j][7]) + "px; " +
		"width:" + asteroidVML[asteroid[j][8]][0]*2 + "px; " +
		"height:" + asteroidVML[asteroid[j][8]][1]*2 + "px; " +
		"rotation:" + parseInt(asteroid[j][2]) + "'");
}


function createVMLGroup(vmlType, name, vml) {
	try{
		var obj1 = document.createElement("<v:group id='" + "group" + name + "' " +
			"style='top:0px; left:0px; width:100%; height:100%;' " +
			"coordsize='" + bodyWidth +", "+bodyHeight + "'" +
			"></v:group>");
		divBodyStatic.appendChild(obj1);
	
		var obj = document.createElement("<v:" + vmlType + " id='" + name + "' " + vml + " />");
		obj1.appendChild(obj);
	} catch(err){debugLog("createVMLGroup:"+err.name+" - "+err.message)}
}


// explode an asteroid
function explodeAsteroid(j) {
	var scored = 0;

	//create an explosion
	createExplosion(asteroid[j][0], asteroid[j][1], asteroid[j][4], asteroid[j][5]);
	
	try{
		if (sound && !demo)
			playSound("explode" + (asteroid[j][10]+1));

		//increase the scale of original
		asteroid[j][10]++;									//scale
		
		//check if we've reached the smallest size asteroid
		if (asteroid[j][10] == 3)
		{
			//remove the object
			asteroid[j][6] = 0;
			document.getElementById("groupasteroid"+j).removeNode(true);
			
			//increase the score
			scored = 100;
			asteroidCount--;
		} else {
			var k = j + initialAsteroids;
			while (asteroid[k][6] != 0)
				k += initialAsteroids;
	
			//remove the original asteroid
			document.getElementById("groupasteroid"+j).removeNode(true);
	
			//create next one
			asteroid[k][0] = asteroid[j][0];								//X
			asteroid[k][1] = asteroid[j][1];								//Y
			asteroid[k][2] = Math.random()*360;								//Rotation
			asteroid[k][3] = Math.random()*(10*difficulty)-(5*difficulty);	//Rotation Speed
			var angle = (Math.random()*360) / 180 * Math.PI;
			var speed = (Math.random()*difficulty)+asteroid[j][10]*1.5;
			asteroid[k][4] = speed * Math.sin(angle);						//Movement x
			asteroid[k][5] = speed * Math.cos(angle);						//Movement y
			asteroid[k][8] = (asteroid[j][10] * maxAsteroidStyles) + parseInt(Math.random()*(maxAsteroidStyles-1) + 0.5);	//Asteroid style
			asteroid[k][6] = asteroidVML[asteroid[k][8]][0];				//Width
			asteroid[k][7] = asteroidVML[asteroid[k][8]][1];				//Height
			asteroid[k][9] = asteroidVML[asteroid[k][8]][2];				//radius
			asteroid[k][10] = asteroid[j][10];								//scale
		
			//shrink 1st asteroid
			asteroid[j][2] = Math.random()*360;								//Rotation
			asteroid[j][3] = Math.random()*(10*difficulty)-(5*difficulty);	//Rotation Speed
			var angle = (Math.random()*360) / 180 * Math.PI;
			var speed = (Math.random()*difficulty)+asteroid[j][10]*1.5;
			asteroid[j][4] = speed * Math.sin(angle);						//Movement x
			asteroid[j][5] = speed * Math.cos(angle);						//Movement y
			asteroid[j][8] = (asteroid[j][10] * maxAsteroidStyles) + parseInt(Math.random()*(maxAsteroidStyles-1) + 0.5);	//Asteroid style
			asteroid[j][6] = asteroidVML[asteroid[j][8]][0];				//Width
			asteroid[j][7] = asteroidVML[asteroid[j][8]][1];				//Height
			asteroid[j][9] = asteroidVML[asteroid[j][8]][2];				//radius
	
			//create the new ones
			createAsteroid(k);
			createAsteroid(j);

			//increase the score
			scored = (asteroid[j][10] == 1) ? 20 : 50;
	
			asteroidCount++;
		}
	} catch(err){debugLog("astExp:"+err.name+" - "+err.message)}

	return scored;
}



// increase the score
function scoreAdd(i) {
	//if we've hit extraLifeAt, grant an extra life
	if ((score+i) % extraLifeAt < (score % extraLifeAt) && lives<5)
	{
		lives++;
		updateLives();
		
		playSound("life");
	}
		
	score = (score + i) % 1000000;
	updateScore();
}



// update the score on screen
function updateScore() {
	var s = "      " + score;
	s = s.substring(s.length - 6);
	displayText(60, 15, "divScore", s);
}



// update the hiscore on screen
function updateHighScore() {
	var s = "      " + highScores[0][0];
	s = s.substring(s.length - 6);
	displayText(240, 22, "divHiscore", s, .5);
}



// update the life counter on screen
function updateLives() {
	//display the lives
	for(var i=0; i<lives; i++)
	{
		try{
			document.getElementById("lives"+i).removeNode(true);
		} catch(err) {}

		var obj = document.createElement("<v:shape id='lives" + i + "' style='width:12px; height:20px; top:40px; left:" + (150-lives*15+i*15) + "px' type='#shiptype' />");
		bodyLives.appendChild(obj);
	}

	//remove any old ones
	if (lives<5)
		for(var i=lives; i<5; i++)
			try{
				document.getElementById("lives"+i).removeNode(true);
			} catch(err) {}
}



// update the UFO's
function updateUFOs() {
try{
	var obj, d, xDist, yDist;

	//should we create one
	if (Math.random()*1000 < 2*difficulty && ufos[nextUFO][2] == 0  && ufoCount<maxUFO && ufoCount<difficulty)
		createUFO();

	//update them
	if (ufoCount > 0)
	{
		for(var j=0; j<maxUFO; j++)
		{
			if(ufos[j][2] != 0)
			{
				obj = document.getElementById("ufo"+j);

				//should the UFO fire
				if (fireCountUFO < maxFireUFO && Math.random()*80 < difficulty)
				{
					//create a fire.  1st check if the next fire is free, clear it if it isnt
					if (fireUFO[nextFireUFO][4] != 0)
					{
						objF = document.getElementById("fireUFO"+nextFireUFO);
						fireCountUFO--;
					} else {
						//create the graphic
						var objF = document.createElement("<v:polyline id='fireUFO"+nextFireUFO+"' points='0,0, 2,2' stroked='true' strokecolor='white' strokeweight='2' filled='false' coordsize='2,2' coordorigin='2,2' />");
						bodyGraphics.appendChild(objF);
					}
				
					//set its initial X, Y
					fireUFO[nextFireUFO][0] = ufos[j][0];
					fireUFO[nextFireUFO][1] = ufos[j][1];

					//set the direction it should fire in
					if (demo)
					{
						var angle = Math.random() * 360;
						fireUFO[nextFireUFO][2] = fireSpeed*Math.sin(angle/180*Math.PI);
						fireUFO[nextFireUFO][3] = fireSpeed*Math.cos(angle/180*Math.PI);
					}
					else
					{
						xDist = ship[0] - ufos[j][0] + ((Math.random()*100/difficulty) - 50/difficulty);
						yDist = ship[1] - ufos[j][1] + ((Math.random()*100/difficulty) - 50/difficulty);

						d = Math.sqrt(xDist*xDist + yDist*yDist);
						//fire in the same direction as the ship, and add on the ship's motion
						fireUFO[nextFireUFO][2] = xDist/d*fireSpeed;
						fireUFO[nextFireUFO][3] = yDist/d*fireSpeed;
					}
					fireUFO[nextFireUFO][4] = maxFireLife;
					objF.style.top = ufos[j][0];
					objF.style.left = ufos[j][1];

					//increase the counters
					fireCountUFO++;
					nextFireUFO = (nextFireUFO+1) % maxFireUFO;
					playSound("sfire");
				}
				
				//move it
				ufos[j][0] += ufos[j][2];
				ufos[j][1] = ((ufos[j][1] + ufos[j][3] + bodyHeight + ufos[j][5]*3) % (bodyHeight + ufos[j][5]*2)) - ufos[j][5];
				
				//should we change it's direction
				if (Math.random()*5000 < 10*difficulty)
					ufos[j][3] = -ufos[j][3];
				
				obj.style.left = ufos[j][0] - ufos[j][4];
				obj.style.top = ufos[j][1] - ufos[j][5];
				
				//if it's gone offscreen, remove it
				if(ufos[j][0] < -ufos[j][4]  || ufos[j][0] > (bodyWidth + ufos[j][4]))
					removeUFO(j);
				//check if any fire has hit it
				else if (checkFire(ufos[j][0], ufos[j][1], ufos[j][7]) || checkShip(ufos[j][0], ufos[j][1], ufos[j][7]))
				{
					//create an explosion
					createExplosion(ufos[j][0], ufos[j][1], ufos[j][2], ufos[j][3]);

					removeUFO(j);
	
					//increase the score
					scoreAdd((ufos[j][6] == 0) ? 200 : 1000);
					playSound("explode1");
				}
			}
		}
	}
} catch(err) {debugLog("updUFO: "+err.name+" - "+err.message)}
}



// create a UFO
function createUFO() {
	try{
		ufoCount++;
		var i = (Math.random()>0.95) ? 1 : 0;	//ufo style
		
		ufos[nextUFO][0] = (Math.random()<.5) ? -ufoVML[i][0] : bodyWidth+ufoVML[i][0];	//X
		ufos[nextUFO][1] = Math.random() * bodyHeight;									//Y
		ufos[nextUFO][2] = (ufos[nextUFO][0]<0) ? Math.random()*2*difficulty+2 : -Math.random()*2*difficulty-2;	//X movement
		ufos[nextUFO][3] = Math.random()*1.5*difficulty+0.5;							//Y movement
		ufos[nextUFO][4] = ufoVML[i][0];												//Centre X
		ufos[nextUFO][5] = ufoVML[i][1];												//Centre Y
		ufos[nextUFO][6] = i;															//style
		ufos[nextUFO][7] = ufoVML[i][2];												//radius

		createVMLGroup("shape", "ufo" + nextUFO, "style='width:" + ufoVML[i][0]*2 + "; " +
			"height:" + ufoVML[i][1]*2 + "; top:" + ufos[nextUFO][1] + "; left:" + ufos[nextUFO][0] +
			"' type='#ufotype" + i + "'");

		if (sound && !demo)
			if (ufos[nextUFO][6] == 0)
				playSound("lsaucer");
			else
				playSound("ssaucer");
		
		nextUFO = (nextUFO+1) % maxUFO;
			
	} catch(err) {debugLog("cr8UFO: "+err.name+" - "+err.message)}
}



// check the ship for a collision
function checkShip(x, y, r) {
	if (demo || offScreen)
		return false;
	
	//check ship bounding box for collision
	var xDist = ship[0] - x;
	var yDist = ship[1] - y;
	var d = Math.sqrt(xDist*xDist + yDist*yDist);

	if (d < (r+shipRadius))
	{
		explodeShip();
		return true;
	}
	
	return false;
}



// check the UFO's for a collision
function checkUFO(x, y, r) {
	var xDist, yDist, d;
	try{
		if (ufoCount>0)
		{
			for(var i=0; i<maxUFO; i++)
			{
				if (ufos[i][2] != 0)
				{
					xDist = ufos[i][0] - x;
					yDist = ufos[i][1] - y;
					d = Math.sqrt(xDist*xDist + yDist*yDist);
		
					//has it collided				
					if (d < (r + ufos[i][7]))
					{
						playSound("explode1");
						removeUFO(i);
	
						return true;
					}
				}
			}
		}
	} catch(err) {debugLog("chkUFO: "+err.name+" - "+err.message)}
	return false;
}



function removeUFO(i) {
	//stop the ufo from updating and remove the object
	ufoCount--;
	ufos[i][2] = 0;
	document.getElementById("groupufo"+i).removeNode(true);

	//is the the last saucer of this type
	var last = true;
	for(var j=0; j<maxUFO && last; j++)
		if (ufos[j][6] == ufos[i][6] && ufos[j][2] != 0 && j!=i)
			last = false;

	if (ufos[i][6] == 0 && last)
		stopSound("lsaucer");
	else if (ufos[i][6] == 1 && last)
		stopSound("ssaucer");
}


function createExplosion(x, y, xm, ym) {
	var obj;
	var count = maxDust-dustCount;
	
	if(count>maxDustPerExplosion)
		count = maxDustPerExplosion;
		
	for(var j=0; j<count; j++)
	{
		//set the direction
		var dxm = Math.random()*2-1+xm;	//X movement
		var dym = Math.random()*2-1+ym;	//Y movement

		//set its initial X, Y
		var dx = (dxm>0) ? x+Math.random()*10 : x-Math.random()*10;
		var dy = (dym>0) ? y+Math.random()*10 : y-Math.random()*10;

		createParticle(dx, dy, dxm, dym);
	}
}



function createParticle(x, y, xm, ym) {
	//create a dust particle.  1st check if the next is free, use old one if not
	if (dust[nextDust][4] != 0)
	{
		obj = document.getElementById("dust"+nextDust);
		dustCount--;
	} else {
		//create the graphic
		var obj = document.createElement("<v:polyline id='dust"+nextDust+"' points='0,0, 1,1' stroked='true' strokecolor='silver' strokeweight='" + (1+Math.random()*1) + "' filled='false' coordsize='1,1' coordorigin='2,2' />");
		bodyDust.appendChild(obj);
	}

	//set the direction
	dust[nextDust][2] = xm;	//X movement
	dust[nextDust][3] = ym;	//Y movement

	//set its initial X, Y
	dust[nextDust][0] = x;
	dust[nextDust][1] = y;

	dust[nextDust][4] = parseInt(Math.random()*20+10);
	
	obj.style.top = dust[nextDust][1];
	obj.style.left = dust[nextDust][0];
	
	//increase the counters
	dustCount++;
	nextDust = (nextDust+1) % maxDust;
}



function updateDust() {
	for(var j=0; j<maxDust; j++)
	{
		if(dust[j][4]>0)
		{
			var obj = document.getElementById("dust"+j);
			
			//move it
			dust[j][0] += dust[j][2];
			dust[j][1] += dust[j][3];
			
			//update the screen
			obj.style.left = parseInt(dust[j][0]);
			obj.style.top = parseInt(dust[j][1]);
			
			//decrease the counter and remove when it's 0
			if(dust[j][4]-- == 1)
			{
				obj.removeNode(true);
				dustCount--;
			}
		}
	}
}



// Animate the ship exploding
function explodeShip() {
	var obj;

	//hide the ship
	vmlShip.style.display="none";
	vmlShipThrust.style.display="none";

	playSound("explode1");

	//create four special dust particles
	for(var j=0; j<4; j++)
	{
		//create a dust particle.  1st check if the next fire is free, clear it if it isnt
		if (dust[nextDust][4] != 0)
		{
			document.getElementById("groupdust"+nextDust).removeNode(true);
			dustCount--;
		}

		//set its initial X, Y
		dust[nextDust][0] = parseInt(ship[0] - ship[6]);
		dust[nextDust][1] = parseInt(ship[1] - ship[7]);

		//set the direction
		dust[nextDust][2] = Math.random()*.3 - .15;	//X movement
		dust[nextDust][3] = Math.random()*.3 - .15;	//Y movement

		//set it's life
		dust[nextDust][4] = parseInt(Math.random()*50) + 30;
		
		//create the graphic
		createVMLGroup("polyline", "dust" + nextDust, "points='"+shipStyle[j][0]+","+shipStyle[j][1] + 
			","+shipStyle[j][2]+","+shipStyle[j][3]+"' stroked='true' strokecolor='white' " +
			"strokeweight='" + strokeweight + "' filled='false' coordsize='12,20' coordorigin='0,0' " +
			"style='top:" + dust[nextDust][1] + "; left:" + dust[nextDust][0] + "; " +
			"rotation:" + parseInt(ship[2]) + "'");
		//increase the counters
		dustCount++;
		nextDust = (nextDust+1) % maxDust;
	}

	//stop the ship from affecting the game
	ship[0] = -1000;	//X
	ship[1] = -1000;	//Y
	ship[2] = 0;		//rotation
	ship[3] = 0;		//movement X
	ship[4] = 0;		//movement Y
	moving = false;
	firing = false;
	offScreen = true;

	//decrease lives
	lives--;

	//update the screen
	updateLives();

	//stop the thrust sound
	stopSound("thrust");

	//setup a timer to put ship back
	if (lives > 0)
		iTimerID2 = window.setTimeout(shipDead, 3000);
	else
	{
		divGameOver.style.display = "inline";
		iTimerID2 = window.setTimeout(gameOver, 8000);
	}
}


function shipDead() {
	var xDist, yDist, d

	//check for no asteroids
	var nearestAsteroid = 10000;

	for(var j=0; j<=maxAsteroids; j++)
		if (asteroid[j][6] != 0)
		{
			xDist = asteroid[j][0] - bodyWidth/2;
			yDist = asteroid[j][1] - bodyHeight/2;
			d = Math.sqrt(xDist*xDist + yDist*yDist);
			
			if (d<nearestAsteroid)
				nearestAsteroid = d;
		}

	if (nearestAsteroid<80 && asteroidCount>0)
		iTimerID2 = window.setTimeout(shipDead, refreshRate);
	else
	{
		//there's a gap, or there's no asteroids
		initialiseShip();
	}
}


//game over
function gameOver() {
	var scoreIndex = -1;
	//is it a high score
	for (var j=0; j<10 && scoreIndex==-1; j++)
		if (score>=highScores[j][0])	scoreIndex = j;

	//shuffle the high scores if required
	if (scoreIndex>-1 && scoreIndex<9)
	{
		for (var j=9; j>scoreIndex; j--)
		{
			highScores[j][0] = highScores[j-1][0];
			highScores[j][1] = highScores[j-1][1];
		}
	}

	//if it's a highscore, add it
	if (scoreIndex>-1)
	{
		divText1.style.display = "inline";
		divText2.style.display = "inline";
		divText3.style.display = "inline";
		divText4.style.display = "inline";
	
		highScores[scoreIndex][0] = score;
		highScores[scoreIndex][1] = "A";
		updateHighScore();
		displayText(200, 300, "divInitials", "A--", 2);
		enteringHiScoreChar = 0;
		enteringHiScore = scoreIndex;
	} else {
		flashStart = 1;
		displayHighScores();
	}

	divGameOver.style.display = "none";
	demo = true;
	startNewGame();
}



//display text on screen
function displayText(x, y, div, text, scale) {
	var obj;
	try{
		var s = text.toUpperCase();
	
		if (!scale) scale = 1;
	
		var groupObj = document.getElementById(div);
		if (groupObj == null) {
			var groupObj = document.createElement("<div id='"+div+"'></div>");
			bodyText.appendChild(groupObj);
		}
	
		var tmp="";
		for(var i=0; i<s.length; i++)
			if (s.charCodeAt(i) != 32)
				tmp += "<v:shape style='width:12px; height:30px; top:" + y + "px; left:" +
					(x+i*(15*scale)) + "px' type='#char" + s.charCodeAt(i) +
					"' coordsize='" + parseInt(12/scale) + "," + parseInt(20/scale) +
					"' />";
	
		groupObj.innerHTML = tmp;
		groupObj.style.display = "inline";
		return groupObj;
	} catch(err) {debugLog("text: "+err.name+" - "+err.message)}
}



// Play a sound through DirectSound
function playSound(s) {
try{
	if (sound && !demo)
	{
		switch (s)
		{
			case "thrust":
				if (cue_thrust == null)
					cue_thrust = DSXLib.PlaySound(s, true);
				break
			case "ssaucer":
				if (cue_ssaucer == null)
					cue_ssaucer = DSXLib.PlaySound(s, true);
				break
			case "lsaucer":
				if (cue_lsaucer == null)
					cue_lsaucer = DSXLib.PlaySound(s, true);
				break
			default:
				DSXLib.PlaySound(s, false);
				break
		}
	}
} catch(err) {debugLog("playSound: " + err.name + " - " + err.message)}
}



// Stop the DirectSound sound
function stopSound(s) {
try{
	if (sound) {
		switch (s)
		{
			case "thrust":
				if (cue_thrust != null) {
					DSXLib.StopSound(cue_thrust);
					cue_thrust = null;
				}
				break
			case "ssaucer":
				if (cue_ssaucer != null) {
					DSXLib.StopSound(cue_ssaucer);
					cue_ssaucer = null;
				}
				break
			case "lsaucer":
				if (cue_lsaucer != null) {
					DSXLib.StopSound(cue_lsaucer);
					cue_lsaucer = null;
				}
				break
		}
	}
} catch(err) {debugLog("stopSound: " + err.name + " - " + err.message)}
}



// Move the ship somewhere random
function hyperspace() {
	ship[0] = Math.random()*(bodyWidth-100) + 50;
	ship[1] = Math.random()*(bodyHeight-100) + 50;
	
	vmlShip.style.top = parseInt(ship[1] - ship[7]);
	vmlShip.style.left = parseInt(ship[0] - ship[6]);
	vmlShipThrust.style.top = vmlShip.style.top;
	vmlShipThrust.style.left = vmlShip.style.left;
	
	vmlShip.style.display="inline";
	offScreen = false;
}



// Register DLL
function registerDLL() {
	try{
		var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
		var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axDllCLSID + "\\";
		var dllPath = System.Gadget.path.replace(RegExp("\\\\", "g"), "/") + "/" + axDllFilename;

		oShell.RegWrite(classRoot, axDllClass, "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", axDllCLSID, "REG_SZ");
		oShell.RegWrite(clsidRoot, axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Class", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + dllPath, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Class", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\CodeBase", "file:///" + dllPath, "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
	} catch(err) {debugLog("registerDLL: "+err.name+" - "+err.message)}
}



// Unregister DLL
function unregisterDLL() {
	if (sound) try{DSXLib.Terminate()} catch(err) {debugLog("Can't terminate XACT")}

	var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axdllCLSID + "\\";

	try{		
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
		oShell.RegDelete(clsidRoot + "ProgId\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\" + axDllVersion + "\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\");
		oShell.RegDelete(clsidRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);
	} catch(err) {debugLog("unregisterDLL: "+err.name+" - "+err.message)}
}



// Try to register the DLL
function activeDLL(root) {
	regRoot = root;

	try{
		registerDLL();
		DSXLib = new ActiveXObject("DSXLib.DSX");
		sound = true;
	} catch(err) {
		DSXLib = null;
		sound = false;
		unregisterDLL();
	}
	return sound;
}



//log a debug entry
function debugLog(str) {
	try{
		System.Debug.outputString(str);
		if (bDebug)
			debugLogFile.WriteLine(str);
	} catch(err) {}
}



//display highscores
function displayHighScores() {
	if (highScores[0][0] == 0)
		return;

	var s, obj;
	obj = displayText(180, 100, "divHighScores", "high scores");
	obj.style.display = "inline";

	for (var j=0; j<10; j++)
	{
		if (highScores[j][0] > 0)
		{
			s = "      " + highScores[j][0];
			s = s.substring(s.length - 6);
			obj = displayText(160, 140 + j*20, "divHighScore"+j, (j<9 ? " " : "") + (j+1) + " " + s + " " + highScores[j][1]);
			obj.style.display = "inline";
		}
	}
}



//hide highscores
function hideHighScores() {
	var obj;

	try{
		divHighScores.style.display = "none";
	} catch(err) {return}

	for (var j=0; j<10; j++)
	{
		try{
			obj = document.getElementById("divHighScore"+j);
			if (obj) obj.style.display = "none";
		} catch(err) {debugLog(err.name+" - "+err.message)}
	}
}



//load the highscores
function loadHighScores() {
	var sLine;

	try{
		if (oFSO.FileExists(gadgetPath + "\\highscores.txt"))
		{
			var oFile = oFSO.OpenTextFile(gadgetPath + "\\highscores.txt");

			for (var j=0; j<10 && !oFile.AtEndOfStream; j++)
			{
				sLine = oFile.ReadLine();
				highScores[j][0] = parseInt(sLine.substring(3));
				highScores[j][1] = sLine.substring(0, 3);
			}
		
			oFile.Close();
		}
	} catch(err) {debugLog("loadHighScores: "+err.name+" - "+err.message)}
}



//save highscores
function saveHighScores() {
	try{
		var oFile = oFSO.CreateTextFile(gadgetPath + "\\highscores.txt", true);
		for (var j=0; j<10; j++)
			oFile.WriteLine(highScores[j][1] + " " + highScores[j][0]);
	
		oFile.Close();
	} catch(err) {debugLog("saveHighScores: "+err.name+" - "+err.message)}
}


var gpButtonA = false;
var gpButtonB = false;
var gpTurning = false;
var gpThumbStuck = false;
var tClearThumbStuck;

//check the XB360 GamePad
function checkGamePad() {
	try{
		if (enteringHiScore > -1) {	//entering HiScore
			if (DSXLib.GamePadButton(gpHyperspace)) {	//stop continuous hits
				if (!gpButtonA) {
					gpButtonA = true;
					enteringHiScoreChar++;
	
					//is this the 3rd initial
					if (enteringHiScoreChar == 3)
					{
						highScores[enteringHiScore][1] = highScores[enteringHiScore][1].replace("-", " ");
						enteringHiScore = -1;
						divInitials.style.display = "none";
						divText1.style.display = "none";
						divText2.style.display = "none";
						divText3.style.display = "none";
						divText4.style.display = "none";
						saveHighScores();
	
						flashStart = 1;
						displayHighScores();
					} else {
						highScores[enteringHiScore][1] += "A";
						displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
					}
				}
			} else if (gpButtonA) {
				gpButtonA = false;
			}

			var gpStick = DSXLib.GamePadThumbStick("Left");
			if (gpStick > 180 && !gpThumbStuck) {				//stop continuous hits
				gpThumbStuck = true;
				tClearThumbStuck = window.setTimeout(clearThumbStuck, 300);
				//get the ascii code and decrease it
				var initials = highScores[enteringHiScore][1];
				var c = initials.charCodeAt(enteringHiScoreChar);
				c--;
				if (c == 64) c = 32;
				else if (c == 31) c = 90;

				highScores[enteringHiScore][1] = initials.substring(0, enteringHiScoreChar) + String.fromCharCode(c) + initials.substring(enteringHiScoreChar + 1);
				displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
			} else if (gpStick > 0 && !gpThumbStuck) {				//stop continuous hits
				gpThumbStuck = true;
				tClearThumbStuck = window.setTimeout(clearThumbStuck, 300);
				//get the ascii code and increase it
				var initials = highScores[enteringHiScore][1];
				var c = initials.charCodeAt(enteringHiScoreChar);
				c++;
				if (c == 91) c = 32;
				else if (c == 33) c = 65;

				highScores[enteringHiScore][1] = initials.substring(0, enteringHiScoreChar) + String.fromCharCode(c) + initials.substring(enteringHiScoreChar + 1);
				displayText(200, 300, "divInitials", (highScores[enteringHiScore][1] + "--").substring(0,3), 2);
			} else if (gpStick == -1) {
				try{window.clearTimeout(tClearThumbStuck)} catch(err) {}

				gpThumbStuck = false;
			}
		} else if (demo) {	// in demo mode
			if (DSXLib.GamePadButton("Start") && haveFocus) {
				demo = false;
				divPushStart.style.display = "none";
				hideHighScores();
				initialiseShip();
				lives = 3;
				
				//display lives
				updateLives();
				startNewGame();
			}

		} else {	// playing game
			// Fire
			if (DSXLib.GamePadButton(gpFire)) {
				if (!offScreen) {
					firing = true;
					gpButtonA = true;
				}
			} else if (gpButtonA) {
				firing = false;
				gpButtonA = false;
			}

			// Hyperspace
			if (DSXLib.GamePadButton(gpHyperspace)) {
				if (!moving && !offScreen) {
					//hide the ship
					vmlShip.style.display="none";
					vmlShipThrust.style.display="none";
					
					//setup a timer to hyperspace
					iTimerID2 = window.setTimeout(hyperspace, 1500);
	
					//stop the ship from affecting the game
					ship[0] = -1000;	//X
					ship[1] = -1000;	//Y
					ship[3] = 0;		//movement X
					ship[4] = 0;		//movement Y
					moving = false;
					firing = false;
					offScreen = true;
				}
			}
			
			// Thrust
			if (DSXLib.GamePadButton(gpThrust)) {
				if (!moving && !offScreen)
				{
					moving = true;
					playSound("thrust");
	
					//change the graphic to one showing thrust
					vmlShip.style.display="none";
					vmlShipThrust.style.display="inline";
					gpButtonB = true;
				}
			} else if (gpButtonB) {
				//change the graphic to non-thrust ship
				vmlShipThrust.style.display="none";
				vmlShip.style.display="inline";
	
				stopSound("thrust");
	
				moving = false;
				gpButtonB = false;
			}

			// Angle
			var gpStick = DSXLib.GamePadThumbStick("Left");
			if (gpStick > -1) {
				gpTurning = true;
					
				// check if we're almost there
				var angleDiff = (gpStick - ship[2] + 360) % 360;
				if (angleDiff < 10 || angleDiff > 350) {
						turning = 0;
						ship[2] = gpStick;
				} else if (angleDiff < 180)
					turning = 10;
				else if (angleDiff > 180)
					turning = -10;
			} else if (gpTurning) {
				gpTurning = false;
				turning = 0;
			}
		}
	} catch(err) {debugLog("checkGamePad: "+err.name+" - "+err.message)}
}

function clearThumbStuck() {
	gpThumbStuck = false;
}
